# from math import exp
from numpy import exp


def QFIM_TMSV(σ, n, η, ηa, loss_type):
    if loss_type == "input":
        aux0 = ((η + (ηa + (-2.0 * (η * ηa)))) ** 3.0) * (
            ((2.0 * ((σ**2) * (-1.0 + ηa))) + (η * (-1.0 + (2.0 * ηa)))) - ηa
        )
        aux1 = (η**2) * (
            1.0
            + (
                (3.0 * ((σ**2) * (((1.0 + (-2.0 * ηa)) ** 2))))
                + ((-8.0 * ηa) + (-4.0 * (ηa**2)))
            )
        )
        aux2 = (-3.0 * (η * ((σ**2) * ((1.0 + ηa) * (-1.0 + (2.0 * ηa)))))) + (
            aux1 + ((η**3.0) * (2.0 + ((-4.0 * ηa) + (8.0 * (ηa**2)))))
        )
        aux3 = ((η * (-1.0 + (2.0 * ηa))) - ηa) * (
            (-2.0 * (η * ((-3.0 + ηa) * ηa))) + ((ηa * ((3.0 * (σ**2)) + ηa)) + aux2)
        )
        aux4 = ((-3.0 + ηa) * ηa) + (
            ((η**2) * (-1.0 + ((3.0 + (-4.0 * ηa)) * ηa)))
            + (η * (-1.0 + (ηa * (4.0 + ηa))))
        )
        aux5 = (2.0 + ((3.0 * η) + ((-3.0 + (2.0 * (η * (3.0 + η)))) * (ηa**2)))) - (
            η * ((10.0 + η) * ηa)
        )
        aux6 = (4.0 * (ηa * (3.0 + (2.0 * ((-3.0 + ηa) * ηa))))) + (
            (σ**2) * ((-1.0 + (2.0 * ηa)) * (1.0 + (6.0 * ((-1.0 + ηa) * ηa))))
        )
        aux7 = (σ**2) + (
            ηa
            * (
                3.0
                + (
                    ηa
                    + (
                        (-2.0 * (ηa**2))
                        + ((σ**2) * (5.0 + (3.0 * (ηa * (-5.0 + (2.0 * ηa))))))
                    )
                )
            )
        )
        aux8 = (
            (η**4.0) * (-2.0 + (2.0 * (ηa * (3.0 + (4.0 * ((-1.0 + ηa) * ηa))))))
        ) + ((2.0 * ((η**3.0) * (-2.0 + aux6))) + (-2.0 * (η * aux7)))
        aux9 = (-38.0 * (ηa**2)) + (
            (22.0 * (ηa**3.0)) + ((σ**2) * (11.0 + (ηa * (-41.0 + (36.0 * ηa)))))
        )
        aux10 = (
            (ηa * ((-2.0 * (σ**2)) + ((1.0 + (3.0 * (σ**2))) * ((-1.0 + ηa) * ηa))))
            + aux8
        ) - ((η**2) * (1.0 + ((3.0 * ηa) + aux9)))
        aux11 = (4.0 * ((n**2) * ((η * aux4) - ((σ**2) * (ηa + (η * aux5)))))) + (
            2.0 * ((n**3.0) * aux10)
        )
        aux12 = (-4.0 * ((n**4.0) * ((-1.0 + ηa) * aux3))) + (
            (
                n
                * (
                    (σ**2)
                    * ((η * (-5.0 + ((2.0 * ηa) + (η * (-2.0 + (6.0 * ηa)))))) - ηa)
                )
            )
            + aux11
        )
        aux13 = (2.0 * (η * (n * ((η * (-1.0 + (2.0 * ηa))) - ηa)))) + (
            (-4.0 * ((n**5.0) * ((-1.0 + ηa) * aux0))) + aux12
        )
        aux14 = 1.0 + (
            (-2.0 * (ηa * (1.0 + (n * ηa))))
            + ((σ**2) * ((n * ((-1.0 + ηa) * (-1.0 + (2.0 * ηa)))) - ηa))
        )
        aux15 = (n * (ηa * (((σ**2) + ηa) - ((σ**2) * ηa)))) + (
            ((η**2) * (n * (1.0 + (2.0 * ((-1.0 + ηa) * ηa))))) + (η * aux14)
        )
        aux16 = (2.0 * ((σ**2) * (aux13 - (η * (σ**2))))) / (
            1.0 + ((σ**2) + (2.0 * (n * ((σ**2) + (ηa + aux15)))))
        )
        aux17 = 2.0 * (
            n
            * (
                ((-1.0 + ((-1.0 + (2.0 * η)) * (n * ηa))) - (η * n))
                * ((η * (-1.0 + (2.0 * ηa))) - ηa)
            )
        )
        aux18 = (σ**2) * (
            (-1.0 + (2.0 * (n * (-1.0 + ηa))))
            * (-1.0 + ((-2.0 * (n * ηa)) + (η * (n * (-2.0 + (4.0 * ηa))))))
        )
        aux19 = (2.0 * ((-1.0 + η) * (η * (n * ηa)))) + (
            (σ**2) * ((η * (-1.0 - n)) + ((-1.0 + (2.0 * η)) * (n * ηa)))
        )
        output = (aux16 / (aux17 + aux18)) / aux19
        return output
    else:
        raise ValueError("Loss type unrecognised.")


def QFIM_SMSV(σ, r, η, loss_type="measurement"):
    """Return QFIM for SMSV. Translated from Mathematica result by Ripoll's converter.

    Args:
        σ (float): signal
        r (float): squeezer parameter such that variances are 1/2*e^+-2r
        η (float): loss
    """
    if loss_type == "measurement":
        aux0 = 0.5 * (
            ((exp((2.0 * r))) - (exp((-2.0 * r)))) * ((((-1.0 + η) ** 2)) * (σ**2))
        )
        aux1 = ((exp((-2.0 * r))) + (exp((2.0 * r)))) * (
            (-1.0 + η) * (((-1.0 + η) * (σ**2)) - η)
        )
        aux2 = (
            2.0
            * ((-1.0 + η) * ((((η - ((exp((2.0 * r))) * (-1.0 + η))) ** 2)) * (σ**2)))
        ) / ((1.0 + (aux0 + (0.5 * aux1))) - ((-1.0 + η) * (η * (-1.0 + (σ**2)))))
        aux3 = 0.5 * (
            ((exp((-2.0 * r))) + (exp((2.0 * r)))) * (((-1.0 + η) * (σ**2)) - η)
        )
        aux4 = (
            0.5 * (((exp((2.0 * r))) - (exp((-2.0 * r)))) * ((-1.0 + η) * (σ**2)))
        ) + aux3
        return aux2 / ((η + aux4) - (η * (σ**2)))
    elif loss_type == "input":
        aux0 = ((0.5 * ((exp(r)) - (exp((-r))))) + (0.5 * ((exp((-r))) + (exp(r))))) - (
            ((exp(r)) - (exp((-r)))) * η
        )
        aux1 = (0.5 * (((exp((2.0 * r))) - (exp((-2.0 * r)))) * (σ**2))) + (
            0.5 * (((exp((-2.0 * r))) + (exp((2.0 * r)))) * (η + (σ**2)))
        )
        aux2 = (2.0 * ((exp((2.0 * r))) * ((aux0**2) * (σ**2)))) / (
            ((-1.0 + η) * aux1) - (η * (-1.0 + (η + (σ**2))))
        )
        aux3 = (0.5 * (((exp((2.0 * r))) - (exp((-2.0 * r)))) * (σ**2))) + (
            0.5 * (((exp((-2.0 * r))) + (exp((2.0 * r)))) * (η + (σ**2)))
        )
        return aux2 / ((-1.0 + ((-1.0 + η) * aux3)) - (η * (-1.0 + (η + (σ**2)))))
    else:
        raise ValueError("Loss type unrecognised.")
